//
//  TextEdit.m
//  FTS
//
//  Created by Michael Heyeck on 2/11/10.
//  Copyright 2010 Fair Oaks Labs, Inc.. All rights reserved.
//

#import "TextEdit.h"


@interface TextEdit ()

- (void)save;
- (void)dismiss;

@end


@implementation TextEdit

@synthesize text;
@synthesize managedObjectContext;
@synthesize textView;


/*
- (id)initWithStyle:(UITableViewStyle)style {
    // Override initWithStyle: if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
    if (self = [super initWithStyle:style]) {
    }
    return self;
}
*/


- (void)viewDidLoad
{
    [super viewDidLoad];

	// Setup header bar
	self.title = self.text?@"Edit Text":@"New Text";
	self.navigationItem.leftBarButtonItem = [[[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemCancel target:self action:@selector(dismiss)] autorelease];
	self.navigationItem.rightBarButtonItem = [[[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemSave target:self action:@selector(save)] autorelease];

	// Initialize display
	textView.text = text.text;

	// Display KB
	[textView becomeFirstResponder];
}


/*
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
}
*/
/*
- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
}
*/
/*
- (void)viewWillDisappear:(BOOL)animated {
	[super viewWillDisappear:animated];
}
*/
/*
- (void)viewDidDisappear:(BOOL)animated {
	[super viewDidDisappear:animated];
}
*/

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/


- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
    // Release anything that's not essential, such as cached data
}


- (void)dealloc
{
	[text release];
	[managedObjectContext release];
	[textView release];
    [super dealloc];
}

#pragma mark Extension methods

- (void)save
{
	if (!text)
	{
		self.text = [NSEntityDescription insertNewObjectForEntityForName:@"Text" inManagedObjectContext:self.managedObjectContext];
	}
	text.text = textView.text;

    NSError* error = nil;
    if (![managedObjectContext save:&error])
	{
		NSLog(@"Unresolved error %@, %@", error, [error userInfo]);
    }

	[self dismiss];
}


- (void)dismiss
{
	[self.navigationController popViewControllerAnimated:YES];
}

@end
